/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type ReferencePosition from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class ReferencePosition extends Sequence {
    
    /**
     * The default constructor.
     */
    public ReferencePosition()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public ReferencePosition(Latitude latitude, Longitude longitude, 
		    PosConfidenceEllipse positionConfidenceEllipse, 
		    Altitude altitude)
    {
	setLatitude(latitude);
	setLongitude(longitude);
	setPositionConfidenceEllipse(positionConfidenceEllipse);
	setAltitude(altitude);
    }
    
    public void initComponents()
    {
	mComponents[0] = new Latitude();
	mComponents[1] = new Longitude();
	mComponents[2] = new PosConfidenceEllipse();
	mComponents[3] = new Altitude();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[4];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new Latitude();
	    case 1:
		return new Longitude();
	    case 2:
		return new PosConfidenceEllipse();
	    case 3:
		return new Altitude();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "latitude"
    public Latitude getLatitude()
    {
	return (Latitude)mComponents[0];
    }
    
    public void setLatitude(Latitude latitude)
    {
	mComponents[0] = latitude;
    }
    
    
    // Methods for field "longitude"
    public Longitude getLongitude()
    {
	return (Longitude)mComponents[1];
    }
    
    public void setLongitude(Longitude longitude)
    {
	mComponents[1] = longitude;
    }
    
    
    // Methods for field "positionConfidenceEllipse"
    public PosConfidenceEllipse getPositionConfidenceEllipse()
    {
	return (PosConfidenceEllipse)mComponents[2];
    }
    
    public void setPositionConfidenceEllipse(PosConfidenceEllipse positionConfidenceEllipse)
    {
	mComponents[2] = positionConfidenceEllipse;
    }
    
    
    // Methods for field "altitude"
    public Altitude getAltitude()
    {
	return (Altitude)mComponents[3];
    }
    
    public void setAltitude(Altitude altitude)
    {
	mComponents[3] = altitude;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "ReferencePosition"
	),
	new QName (
	    "ITS-Container",
	    "ReferencePosition"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"Latitude"
			    ),
			    new QName (
				"ITS-Container",
				"Latitude"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Latitude(-900000000), 
				    new Latitude(900000001),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-900000000),
				new java.lang.Long(900000001)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMicrodegreeNorth",
					10
				    ),
				    new MemberListElement (
					"oneMicrodegreeSouth",
					-10
				    ),
				    new MemberListElement (
					"unavailable",
					900000001
				    )
				}
			    )
			)
		    ),
		    "latitude",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"Longitude"
			    ),
			    new QName (
				"ITS-Container",
				"Longitude"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Longitude(-1799999999), 
				    new Longitude(1800000001),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-1799999999),
				new java.lang.Long(1800000001)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMicrodegreeEast",
					10
				    ),
				    new MemberListElement (
					"oneMicrodegreeWest",
					-10
				    ),
				    new MemberListElement (
					"unavailable",
					1800000001
				    )
				}
			    )
			)
		    ),
		    "longitude",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"PosConfidenceEllipse"
			    ),
			    new QName (
				"ITS-Container",
				"PosConfidenceEllipse"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "PosConfidenceEllipse"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "PosConfidenceEllipse"
				)
			    ),
			    0
			)
		    ),
		    "positionConfidenceEllipse",
		    2,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"Altitude"
			    ),
			    new QName (
				"ITS-Container",
				"Altitude"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "Altitude"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "Altitude"
				)
			    ),
			    0
			)
		    ),
		    "altitude",
		    3,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' ReferencePosition object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' ReferencePosition object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for ReferencePosition
